﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Model
{
    // This class holds states in the scope of the entire gameplay
    static class GameState
    {
        public static readonly int SCREEN_HEIGHT = 640;
        public static readonly int SCREEN_WIDTH = 960;

        public static bool playableUnitSelected { get; set; } //indicates playable selected unit
        public static Unit selectedUnit { get; set; } // indicates current selected unit
        public static Unit unitToAttack { get; set; } // indicates the unit to attack
        public static Player currentPlayer { get; set; } // indicates player 1
        public static Player enemyPlayer { get; set; } // indicates enemy player (player 2)
        public static bool dropDownMenuOpen { get; set; } // indicates whether drop down menu should be open
        public static bool beforeMove { get; set; } // true before unit moves, false after it moves. Used to determine what tiles are highlighted
        public static bool isAnimating { get; set; } // indicates whether an animation sequence is on screen
        public static LinkedList<Node> moveableNodes { get; set; }   // holds moveable nodes that can be retreived without calling path finding
    }

    enum GameMenuState // enumerated list for different possible Game States
    {
        MainMenu,       // menu screen
        HowToPlay,      // Instruction Screen 1
        HowToPlay2,     // Instruction Screen 2
        HowToPlay3,     // Instructions Screen 3
        Playing,        // Playing game Screen
        DropDownMenu,   // Drop down menu for action
        CharMenu,       // character drop down info menu
        AttackMenu      // attack menu
    }

    enum TurnState //what the current turn state is (per unit)
    {
        Wait,
        AttackMenu,
        Attack,
        Move,
        Items
    }
}
