﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

using View;

namespace Model
{
    interface Unit
    {
        bool Alive { get; set; }                // whether unit is dead or alive
        int Hp { get; set; }                            // returns and sets unit's HP
        int Str { get; set; }                           // returns and sets unit's strength
        int Int { get; set; }                           // returns and sets unit's intelligence
        int Skill { get; set; }                         // returns and sets unit's skill
        int Speed { get; set; }                         // returns and sets unit's speed
        int Def { get; set; }                       // returns and sets unit's defense
        int Res { get; set; }                    // returns and sets unit's resistance
        int Level { get; set; }                 // returns and sets unit's level
        int getMovability();                    // returns the unit's movability (number of spaces the unit can move in one turn)
        int getStats(int i);                    // returns stat located at i (in order from 0-6: lvl, str, mag, skill, spd, def, res)


       
        
        
       
        void setEquippedWeapon(Weapon w);       // sets the unit's currently equipped weapon
        //void setEquipableWeapons(Weapon add);  // need to update the weapon array, put new weapon into it
        bool isButtonActive(MenuButtonType buttonType);     // indicates whether a button has already been previously selected or not
        void setMenuButtonCoordinates(Vector2 pixelCoordinates);    // sets the coordinates of menu buttons
        void animate(int direction);            // animate sprite walking the direction specified
        void setInitialStats();                 // sets initial unit stats upon creation
        Texture2D getSpriteImage();             // returns the sprite image of the unit
        Texture2D getButtonImage(MenuButtonType buttonType);        // returns the button texture at index i
        Texture2D getCharInfo();                // returns the char info screen texture
        Tuple<int, int> Position { get; set;}   // gets and sets unit's position by tile
        Vector2 PixelCoordinates { get; set; }
        MenuButton getMenuButtonAt(int i);

        MenuButton[] getMenuButtons();          // returns the dropdown menu buttons of the unit
        Rectangle getCurrentFrame();            // returns the current sprite frame in animation sequence
        Weapon[] getEquipableWeapons();         // returns array of equipable weapons
        Weapon getEquippedWeapon();             // returns weapon the unit is currently equipping
        UnitType getClass();                    // returns unit's class (warrior, mage, archer)
    }

    enum UnitType { Warrior, Archer, Mage };    //defines the possible classes of a unit
}
